# all files / ol/ observable.js

100% Statements 23/23
100% Branches 0/0
100% Functions 7/7
100% Lines 23/23

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    1351×

    1×
    1×
    1×

    1×

    7181×

    7181×

    1×

    1×
    3×

    1×
    8828×
    8828×

    1×

    1×
    1966×

    1×
    72×

    1×
    69×

    1×
    3×

    1×
     goog.provide('ol.Observable');

    goog.require('goog.events');
    goog.require('goog.events.EventTarget');
    goog.require('goog.events.EventType');

    /**
     * @classdesc
     * Abstract base class; normally only used for creating subclasses and not
     * instantiated in apps.
     * An event target providing convenient methods for listener registration
     * and unregistration. A generic `change` event is always available through
     * {@link ol.Observable#changed}.
     *
     * @constructor
     * @extends {goog.events.EventTarget}
     * @fires change
     * @struct
     * @api stable
     */
    ol.Observable = function() {

      goog.base(this);

      /**
       * @private
       * @type {number}
       */
      this.revision_ = 0;

    };
    goog.inherits(ol.Observable, goog.events.EventTarget);

    /**
     * Removes an event listener using the key returned by `on()` or `once()`.
     * @param {goog.events.Key} key The key returned by `on()` or `once()`.
     * @api stable
     */
    ol.Observable.unByKey = function(key) {
      goog.events.unlistenByKey(key);
    };

    /**
     * Increases the revision counter and dispatches a 'change' event.
     * @api
     */
    ol.Observable.prototype.changed = function() {
      ++this.revision_;
      this.dispatchEvent(goog.events.EventType.CHANGE);
    };

    /**
     * Triggered when the revision counter is increased.
     * @event change
     * @api
     */

    /**
     * Dispatches an event and calls all listeners listening for events
     * of this type. The event parameter can either be a string or an
     * Object with a `type` property.
     *
     * @param {goog.events.EventLike} event Event object.
     * @function
     * @api
     */
    ol.Observable.prototype.dispatchEvent;

    /**
     * Get the version number for this object.  Each time the object is modified,
     * its version number will be incremented.
     * @return {number} Revision.
     * @api
     */
    ol.Observable.prototype.getRevision = function() {
      return this.revision_;
    };

    /**
     * Listen for a certain type of event.
     * @param {string|Array.<string>} type The event type or array of event types.
     * @param {function(?): ?} listener The listener function.
     * @param {Object=} opt_this The object to use as `this` in `listener`.
     * @return {goog.events.Key} Unique key for the listener.
     * @api stable
     */
    ol.Observable.prototype.on = function(type, listener, opt_this) {
      return goog.events.listen(this, type, listener, false, opt_this);
    };

    /**
     * Listen once for a certain type of event.
     * @param {string|Array.<string>} type The event type or array of event types.
     * @param {function(?): ?} listener The listener function.
     * @param {Object=} opt_this The object to use as `this` in `listener`.
     * @return {goog.events.Key} Unique key for the listener.
     * @api stable
     */
    ol.Observable.prototype.once = function(type, listener, opt_this) {
      return goog.events.listenOnce(this, type, listener, false, opt_this);
    };

    /**
     * Unlisten for a certain type of event.
     * @param {string|Array.<string>} type The event type or array of event types.
     * @param {function(?): ?} listener The listener function.
     * @param {Object=} opt_this The object which was used as `this` by the
     * `listener`.
     * @api stable
     */
    ol.Observable.prototype.un = function(type, listener, opt_this) {
      goog.events.unlisten(this, type, listener, false, opt_this);
    };

    /**
     * Removes an event listener using the key returned by `on()` or `once()`.
     * Note that using the {@link ol.Observable.unByKey} static function is to
     * be preferred.
     * @param {goog.events.Key} key The key returned by `on()` or `once()`.
     * @function
     * @api stable
     */
    ol.Observable.prototype.unByKey = ol.Observable.unByKey;